;    ᭮ ணࠬ

; "  POCSAG"

; 뭥ᥭ  ⤥ 䠩 ⮫쪮  㤮⢠ ࠡ
;  ᭮ 㫥 - rxpocsag.asm


;	************   timer interrupt  **************
; 
		movwf temp_w		;save w & status
		swapf status,w 	
		bcf status,rp0
		movwf temp_status
;---------------------------------------
;-10 for rtcc		
		
		movlw 256 -104 + 10
		movwf rtcc
		bcf intcon,rtif

		jmp int_timer


;---------------------------------------
;   !!!
;---------------------------------------

;get_data	clr PCLATH
;		movwf PCL
;copy_r	
;
;copy_r		d_b 13
;		d_b 10
;		d_b 13
;		d_b 10
;
;		d_b 1
;		d_b 30
;		retlw '*'
;
;		d_b 13
;		d_b 10
;
;		d_b 1
;		d_b 5
;		retlw '*'
; d_b ' '
; d_b 'P'
; d_b 'O'
; d_b 'C'
; d_b 'S'
; d_b 'A'
; d_b 'G'
; d_b ' '
; d_b 'R'
; d_b 'E'
; d_b 'A'
; d_b 'D'
; d_b 'E'
; d_b 'R'
; d_b ' '
; d_b '2'
; d_b '0'
; d_b '0'
; d_b '0'
; d_b ' '
;
;		d_b 1
;		d_b 5
;		retlw '*'
;
;		d_b 13
;		d_b 10
;
;		d_b 1
;		d_b 30
;		retlw '*'
;
;		d_b 13
;		d_b 10
;		d_b 0
;
;

;******************************************************
;------------------------------------------------------
int_timer	incf count_in,f
		incf timer_9600,f



;======================================================
;	Tx bajt
;	txreg <- bajt	
;	status_tx <- ffh 	start 
;
;	read	status_tx=0	ready for transmit
;------------------------------------------------------

		movf status_tx,w
		jz end_tx		;nothing to send

		incf status_tx,w
		jne tx_1		;not start impuls

		bcf port_a,4		;start 
		movlf status_tx,10
		jmp end_tx

tx_1		djnz status_tx,tx_2
		jmp end_tx		;end of stop impuls

tx_2		decf status_tx,w
		jne tx_3

		bsf port_a,4		;stop
		jmp end_tx

tx_3		rrf txreg,f
		jc txx
		bcf port_a,4
		jmp end_tx
txx		bsf port_a,4
end_tx
;------------------------------------------------------


;======================================================
; Set frequency from 9600 Hz to 1200 Hz or 512 Hz
;======================================================

set_freq	jb status_sync,0,s_512

		movf count_in,w
		xorlw 8  		;1200 = 9600/8
		je t512c		;end of 1200
		jmp t512		
		
s_512		movlw 0c0h		;512 = 9600*4/(3*19+18)
		andwf status_sync,w
		movlw 18		
		jz bb512
		movlw 19
bb512		xorwf count_in,w
		jne t512
		movlw 40h		;end of 512
		addwf status_sync,f
t512c		clr count_in
t512		
;-----------------------------------------------------



;=====================================================
; Set phase for 1200 Hz or 512 Hz  (PLL)
;=====================================================
set_phase	clc
		jnb port_a,3,m1		;    !!!!!!!!!!!!!!!!!!	
		stc
m1		rlf status_s,f		;last 8 bits

		movf status_s,w
		andlw 3 
		xorlw 1 
		;je promena		;01
		;xorlw 3 
		jne bez_promene		;00 or 11
		
;---------------------------------------
;	01 ;or 10
;---------------
promena		jb status_sync,0,b_512

		movlw 6			;1200
		subwf count_in,w
		jc pro			;6,7 		(+25%)
		movlw 3
		subwf count_in,w
		jnc pro			;0 & 1,2 	(-25%)	
bez_prom	incf count_in,f
		jmp bez_promene

;---------------
b_512		movlw 15		;512
		subwf count_in,w
		jc pro			;15,16,17,18,19 (+25%)
		movlw 4
		subwf count_in,w
		jc bez_prom		;0 & 1,2,3	(-15%)
		
pro		clr count_in
bez_promene
;---------------------------------------

;=======================================
; get bit
;---------------------------------------

		jb status_sync,0,d_512
		movlw 4 		;1200	bps
		jmp get_bit
d_512		movlw 8			;512	bps
get_bit		xorwf count_in,w
		jne end_bit

;---------------
		incf counter,f
		bsf status_sync,3

;---------------------------------------
;  bit filter
;---------------------------------------
		movf status_s,w
		andlw 7
		xorlw 3			
		je bit_1		;011
		xorlw 7			
		je bit_0		;100
		jnb status_s,2,bit_0
bit_1		stc
		jmp bit_e
bit_0		clc
bit_e
;---------------------------------------

		rlf data_in_temp,f
		movf counter,w
		andlw 7
		jne end_bit
		movlf counter,80h
		movrr data_in,data_in_temp
end_bit
;---------------------------------------

;---------------------------------------
; end of interrupt
;---------------------------------------
		swapf temp_status,w
		movwf status
		swapf temp_w,f
		swapf temp_w,w
		retfie
;---------------------------------------
;---------------------------------------
