;    ᭮ ணࠬ

; "  POCSAG"

; 뭥ᥭ  ⤥ 䠩 ⮫쪮  㤮⢠ ࠡ
;  ᭮ 㫥 - rxpocsag.asm


;***************************************
; bin 21 bit _data --> bcd r6,r5,r4,r3
;---------------------------------------

bin_bcd		movlf r1,21
		clr r3
		clr r4
		clr r5
		clr r6
next_lld	rlf _data+2,f
		rlf _data+1,f
		rlf _data,f

		rlf r6,f
		rlf r5,f
		rlf r4,f
		rlf r3,f

		djnz r1,adj_bcd
		ret
;---------------
adj_bcd		movlw 3		;adj r6
		addwf r6,w
		movwf r0
		btfsc r0,3
		movwf r6
		movlw 30h
		addwf r6,w
		movwf r0
		btfsc r0,7
		movwf r6

		movlw 3		;adj r5
		addwf r5,w
		movwf r0
		btfsc r0,3
		movwf r5
		movlw 30h
		addwf r5,w
		movwf r0
		btfsc r0,7
		movwf r5

		movlw 3		;adj r4
		addwf r4,w
		movwf r0
		btfsc r0,3
		movwf r4
		movlw 30h
		addwf r4,w
		movwf r0
		btfsc r0,7
		movwf r4

		movlw 3		;adj r3
		addwf r3,w
		movwf r0
		btfsc r0,3
		movwf r3
		movlw 30h
		addwf r3,w
		movwf r0
		btfsc r0,7
		movwf r3

		jmp next_lld
;---------------------------------------

;***************************************
test_frame_sync	movlw 7ch
		xorwf _data,w
		jne er_t
		movlw 0d2h
		xorwf _data+1,w
		jne er_t
		movlw 15h
		xorwf _data+2,w
		;jne er_t
		;movlw 0d8h
		;xorwf _data+3,w
er_t		ret

;***************************************
test_idle	movlw 7ah
		xorwf _data,w
		jne er_t
		movlw 89h
		xorwf _data+1,w
		jne er_t
		movlw 0c1h
		xorwf _data+2,w
		;jne er_t
		;movlw 97h
		;xorwf _data+3,w
		ret


;***************************************
; 32-bit in --> data (0-3)
;---------------------------------------
get_dword	call get_bajt
		jc er_dd
		movwf _data
		call get_bajt
		jc er_dd
		movwf _data+1
		call get_bajt
		jc er_dd
		movwf _data+2
		call get_bajt
		jc er_dd
		movwf _data+3
er_dd		ret

;---------------------------------------

;**************************************
; ret: 	c=0 w=bit (byte)
;	c=1 time over error
;--------------------------------------
get__bit	movf timer_9600,w
		addlw 256-2
		movwf r7
		
nex_b		movf r7,w
		xorwf timer_9600,w
		je time_ee

		jnb status_sync,3,nex_b
;---------------
		clc
		bcf status_sync,3
		movf data_in_temp,w
		ret
;---------------------------------------


;***************************************
; ret: 	c=0 w=byte
;	c=1 time over error
;---------------------------------------
get_bajt	movf timer_9600,w
		addlw 256-2		;time max
		movwf r7
		
nex_gb		movf r7,w
		xorwf timer_9600,w
		je time_ee		;time over error

		jnb counter,7,nex_gb	;wait for byte

;---------------
		bcf counter,7

		jnb status_sync,2,normal
		comf data_in,f		;data invert
normal		movf data_in,w
		clc
		ret

time_ee		stc
		ret

;---------------------------------------


